var aacObserver = {
    observerService: null,
    initialize: function() {
        aacObserver.observerService = Components.classes["@mozilla.org/observer-service;1"]
                                        .getService(Components.interfaces.nsIObserverService);
        aacObserver.observerService.addObserver(aacObserver, "mail:composeOnSend", false);
        removeEventListener("load", aacObserver.initialize, false);
    },
    observe: function (subject, topic, data) {
        autoAddressCleanerMain(GenericSendMessage.msgType);
    },
    complete: function() {
        aacObserver.observerService.removeObserver(aacObserver, "mail:composeOnSend");
        removeEventListener("unload", aacObserver.initialize, false);
    }
};

addEventListener("load", aacObserver.initialize, false);
addEventListener("unload", aacObserver.complete, false);

function autoAddressCleanerMain(msgType)
{
	if (gMsgCompose && gMsgCompose.compFields)
	{
	    if (msgType == nsIMsgCompDeliverMode.Save ||
	      msgType == nsIMsgCompDeliverMode.SaveAsDraft ||
	      msgType == nsIMsgCompDeliverMode.AutoSaveAsDraft ||
	      msgType == nsIMsgCompDeliverMode.SaveAsTemplate)
	    { 
            //do nothing
        }
        else
        {
		    if (gMsgCompose.compFields.to)
		        gMsgCompose.compFields.to = stripDisplayName(gMsgCompose.compFields.to);
		        
		    if (gMsgCompose.compFields.cc)
		        gMsgCompose.compFields.cc = stripDisplayName(gMsgCompose.compFields.cc);
		        
		    if (gMsgCompose.compFields.bcc)
		        gMsgCompose.compFields.bcc = stripDisplayName(gMsgCompose.compFields.bcc);
		}
    }
}

function stripDisplayName(addresses)
{
    var msgHeaderParser = Components.classes["@mozilla.org/messenger/headerparser;1"]
                            .getService(Components.interfaces.nsIMsgHeaderParser);
    
    var strippedAddresses = {};
    var fullNames = {};
    var names = {};
    var numAddresses =  0;
    
    msgHeaderParser.parseHeadersWithArray(addresses, strippedAddresses,
                                                    names, fullNames, numAddresses);
    
    return strippedAddresses.value.join(",");
}
